﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Infragistics.Windows.DataPresenter.ExcelExporter;
using System.Diagnostics;
using Infragistics.Windows.DataPresenter;

namespace ExportToExcelWithHeaderStyle
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
        }

        private void button1_Click(object sender, RoutedEventArgs e)
        {
            DataPresenterExcelExporter exporter = new DataPresenterExcelExporter();
            exporter.HeaderLabelExporting += new EventHandler<HeaderLabelExportingEventArgs>(exporter_HeaderLabelExporting);

            exporter.CellExporting += new EventHandler<CellExportingEventArgs>(exporter_CellExporting);

            exporter.Export(xamDataGrid1, "excel.xlsx", Infragistics.Documents.Excel.WorkbookFormat.Excel2007);

            Process.Start("excel.xlsx");
        }

        void exporter_CellExporting(object sender, CellExportingEventArgs e)
        {
            Style cellStyle = e.Field.Settings.CellValuePresenterStyle;
            if (cellStyle == null)
            {
                if (Application.Current.Resources.Contains(typeof(CellValuePresenter)))
                    cellStyle = Application.Current.Resources[typeof(CellValuePresenter)] as Style;
            }

            if (cellStyle != null)
            {
                Setter bgSetter = cellStyle.Setters.Where(s => s is Setter && (s as Setter).Property.Name.Equals("Background")).FirstOrDefault() as Setter;
                Setter fgSetter = cellStyle.Setters.Where(s => s is Setter && (s as Setter).Property.Name.Equals("Foreground")).FirstOrDefault() as Setter;

                if (bgSetter != null && fgSetter != null)
                {
                    e.FormatSettings.FontColor = (fgSetter.Value as SolidColorBrush).Color;
                    e.FormatSettings.FillPatternForegroundColor = (bgSetter.Value as SolidColorBrush).Color;
                }
            }
        }

        void exporter_HeaderLabelExporting(object sender, HeaderLabelExportingEventArgs e)
        {
            Style labelStyle = e.Field.Settings.LabelPresenterStyle;
            if (labelStyle == null)
            {
                if (Application.Current.Resources.Contains(typeof(LabelPresenter)))
                    labelStyle = Application.Current.Resources[typeof(LabelPresenter)] as Style;
            }

            if (labelStyle != null)
            {
                Setter bgSetter = labelStyle.Setters.Where(s => s is Setter && (s as Setter).Property.Name.Equals("Background")).FirstOrDefault() as Setter;
                Setter fgSetter = labelStyle.Setters.Where(s => s is Setter && (s as Setter).Property.Name.Equals("Foreground")).FirstOrDefault() as Setter;

                if (bgSetter != null && fgSetter != null)
                {
                    e.FormatSettings.FontColor = (fgSetter.Value as SolidColorBrush).Color;
                    e.FormatSettings.FillPatternForegroundColor = (bgSetter.Value as SolidColorBrush).Color;
                }
            }
        }
    }
}
